package com.ruoyi.mall.service.impl;

import java.util.List;
import java.util.Map;

import com.ruoyi.common.utils.DateUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import com.ruoyi.mall.mapper.MallMemberCouponMapper;
import com.ruoyi.mall.domain.MallMemberCoupon;
import com.ruoyi.mall.service.IMallMemberCouponService;

import javax.annotation.Resource;

/**
 * 用户优惠券Service业务层处理
 *
 * @author ruoyi
 * @date 2024-06-24
 */
@Service
public class MallMemberCouponServiceImpl implements IMallMemberCouponService
{
    @Resource
    private MallMemberCouponMapper mallMemberCouponMapper;

    /**
     * 查询用户优惠券
     *
     * @param memberCouponId 用户优惠券主键
     * @return 用户优惠券
     */
    @Override
    public MallMemberCoupon selectMallMemberCouponByMemberCouponId(Long memberCouponId)
    {
        return mallMemberCouponMapper.selectMallMemberCouponByMemberCouponId(memberCouponId);
    }

    /**
     * 查询用户优惠券列表
     *
     * @param mallMemberCoupon 用户优惠券
     * @return 用户优惠券
     */
    @Override
    public List<MallMemberCoupon> selectMallMemberCouponList(MallMemberCoupon mallMemberCoupon)
    {
        return mallMemberCouponMapper.selectMallMemberCouponList(mallMemberCoupon);
    }

    /**
     * 新增用户优惠券
     *
     * @param mallMemberCoupon 用户优惠券
     * @return 结果
     */
    @Override
    public int insertMallMemberCoupon(MallMemberCoupon mallMemberCoupon)
    {
        mallMemberCoupon.setCreateAt(DateUtils.getTime());
        return mallMemberCouponMapper.insertMallMemberCoupon(mallMemberCoupon);
    }

    /**
     * 修改用户优惠券
     *
     * @param mallMemberCoupon 用户优惠券
     * @return 结果
     */
    @Override
    public int updateMallMemberCoupon(MallMemberCoupon mallMemberCoupon)
    {
        return mallMemberCouponMapper.updateMallMemberCoupon(mallMemberCoupon);
    }

    /**
     * 批量删除用户优惠券
     *
     * @param memberCouponIds 需要删除的用户优惠券主键
     * @return 结果
     */
    @Override
    public int deleteMallMemberCouponByMemberCouponIds(Long[] memberCouponIds)
    {
        return mallMemberCouponMapper.deleteMallMemberCouponByMemberCouponIds(memberCouponIds);
    }

    /**
     * 删除用户优惠券信息
     *
     * @param memberCouponId 用户优惠券主键
     * @return 结果
     */
    @Override
    public int deleteMallMemberCouponByMemberCouponId(Long memberCouponId)
    {
        return mallMemberCouponMapper.deleteMallMemberCouponByMemberCouponId(memberCouponId);
    }

    /**
     * 查看优惠券是否可用
     *
     * @param couponId 优惠券ID
     * @param userId 用户ID
     * @return 结果
     */
    @Override
    public MallMemberCoupon checkCouponUsed(Long couponId, Long userId) {
        return mallMemberCouponMapper.checkCouponUsed(couponId, userId);
    }
}
